package atomicstryker.battletowers.common;

import io.netty.buffer.ByteBuf;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.ai.EntityAIAttackMelee;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIWatchClosest;
import net.minecraft.entity.monster.EntityMob;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraft.util.DamageSource;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.SoundEvent;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.MathHelper;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.registry.IEntityAdditionalSpawnData;

public class AS_EntityGolem extends EntityMob implements IEntityAdditionalSpawnData
{
    
    private final static DataParameter<Boolean> AWAKE = EntityDataManager.<Boolean>func_187226_a(AS_EntityGolem.class, DataSerializers.field_187198_h);
    
    private int rageCounter;
    private int explosionAttack;
    private int towerID;
    private int drops;
    private int attackCounter;
    
    private int towerX = -1;
    private int towerY = -1;
    private int towerZ = -1;
    
    @SuppressWarnings({ "unchecked", "rawtypes" })
	public AS_EntityGolem(World world)
    {
        super(world);
        this.func_70105_a(1.1F, 4.0F);
        field_70177_z = 0.0F;
        rageCounter = 0;
        explosionAttack = 0;
        field_70178_ae = true;
        drops = 1;
        func_70012_b(field_70165_t, field_70163_u, field_70161_v, 0.0F, 0.0F);
        attackCounter = 0;
        
        func_110148_a(SharedMonsterAttributes.field_111267_a).func_111128_a(300.0d); // max health
        func_70606_j(func_110138_aP());
        
        func_110148_a(SharedMonsterAttributes.field_111264_e).func_111128_a(7.0d); // attack damage
        func_110148_a(SharedMonsterAttributes.field_111263_d).func_111128_a(0.3d); // movespeed
        
        field_70714_bg.func_75776_a(0, new EntityAISwimming(this));
        field_70714_bg.func_75776_a(1, new EntityAIAttackMelee(this, 1.0d, true));
        field_70714_bg.func_75776_a(2, new EntityAIWatchClosest(this, EntityPlayer.class, 8.0F));
        field_70715_bh.func_75776_a(1, new EntityAIHurtByTarget(this, false));
        field_70715_bh.func_75776_a(2, new EntityAINearestAttackableTarget(this, EntityPlayer.class, true, true));
    }

    public AS_EntityGolem(World world, int i)
    {
        this(world);
		towerID = i;
		this.updateGolemType();
    }
    
    @Override
    protected void func_70619_bc()
    {
        if (!this.getIsDormant())
        {
            super.func_70619_bc();
        }
    }
    
    
    @Override
	public void func_70636_d()
    {
        if (!this.getIsDormant())
        {
            super.func_70636_d();
        }
    }

	@Override
	public void writeSpawnData(ByteBuf data)
	{
		data.writeInt(this.towerID);
	}

	@Override
	public void readSpawnData(ByteBuf data)
	{
		towerID = data.readInt();
		this.updateGolemType();
	}

	private void updateGolemType()
	{
		drops = 5 + towerID;
		func_110148_a(SharedMonsterAttributes.field_111264_e).func_111128_a(7.0f + towerID);
		func_110148_a(SharedMonsterAttributes.field_111267_a).func_111128_a(150f + 50f*towerID);
		func_70606_j(func_110138_aP());
	}

    @Override
    protected void func_70088_a()
    {
        super.func_70088_a();
        field_70180_af.func_187214_a(AWAKE, true); // dormant dataManager
    }

    public void setDormant()
    {
        if (!field_70170_p.field_72995_K)
        {
            field_70180_af.func_187227_b(AWAKE, true);
        }
    }

    public void setAwake()
    {
        if (!field_70170_p.field_72995_K)
        {
            if (getIsDormant())
            {
                field_70170_p.func_184133_a(null, func_180425_c(), AS_BattleTowersCore.instance.soundGolemAwaken, SoundCategory.HOSTILE, func_70599_aP() * 2.0F, ((field_70146_Z.nextFloat() - field_70146_Z.nextFloat()) * 0.2F + 1.0F) * 1.8F);
            }
            
            field_70180_af.func_187227_b(AWAKE, false);
        }
    }

    public boolean getIsDormant()
    {
    	return field_70180_af.func_187225_a(AWAKE);
    }
    
    @Override
    public boolean func_70097_a(DamageSource damageSource, float amount)
    {
        if (damageSource.func_76346_g() != null
        && damageSource.func_76346_g() instanceof EntityLivingBase)
        {
            setAwake();
            func_70624_b((EntityLivingBase) damageSource.func_76346_g());
        }
        
        return super.func_70097_a(damageSource, amount);
    }

	@Override
    public void func_70106_y()
    {
        super.func_70106_y();
    }

	@Override
    public void func_70645_a(DamageSource var1)
    {
    	super.func_70645_a(var1);
    	Entity entity = var1.func_76346_g();

        if(field_70744_aE > 0 && entity != null)
        {
            entity.func_70084_c(this, field_70744_aE);
        }
        if(!field_70170_p.field_72995_K)
        {
            int i = drops;
            for(int j = 0; j < i; j++)
            {
                func_70099_a(new ItemStack(Items.field_151045_i, 1), 0f);
				func_70099_a(new ItemStack(Items.field_151137_ax, 1), 0f);
            }

            i = field_70146_Z.nextInt(4) + 8;
            for(int k = 0; k < i; k++)
            {
                func_70099_a(new ItemStack(Blocks.field_150435_aG, 1), 0f);
            }
			if(func_70638_az() != null && (AS_BattleTowersCore.instance.towerDestroyerEnabled != 0) && towerY > 50)
			{
				AS_BattleTowersCore.onBattleTowerDestroyed(new AS_TowerDestroyer(field_70170_p, new BlockPos(towerX, towerY, towerZ), System.currentTimeMillis(), func_70638_az()));
			}
        }
        field_70170_p.func_72960_a(this, (byte)3);
    }

	@Override
    public void func_70653_a(Entity entity, float i, double d, double d1)
    {
        //moveSpeed = 0.25F + (float)((double)(450 - health) / 1750D);
        if(field_70146_Z.nextInt(5) == 0)
        {
            field_70159_w *= 1.5D;
            field_70179_y *= 1.5D;
            field_70181_x += 0.60000002384185791D;
        }
        //rageCounter = 150;
    }
    
    @Override
    public void func_70071_h_()
    {
        if(!this.getIsDormant())
        {		
			if(func_70638_az() == null || !func_70638_az().func_70089_S())
            {
			    func_70606_j(func_110138_aP());
                rageCounter = 125;
                explosionAttack = 0;

                if (this.field_70122_E)
                {
                    this.setDormant();
                }
            }
			else if(rageCounter <= 0 && explosionAttack == 0)
            {
                field_70170_p.func_184133_a(null, func_180425_c(), AS_BattleTowersCore.instance.soundGolemSpecial, SoundCategory.HOSTILE, func_70599_aP() * 2.0F, ((field_70146_Z.nextFloat() - field_70146_Z.nextFloat()) * 0.2F + 1.0F) * 1.8F);
			    field_70181_x += 0.9D;
			    explosionAttack = 1;
            }
			else if((rageCounter <= -30 || field_70122_E) && explosionAttack == 1)
            {
                if(func_110143_aJ() <= func_110138_aP()/2) // getEntityHealth
                {
                    func_70606_j(func_110143_aJ() + 20);
                }

				if (!field_70170_p.field_72995_K && (this.field_70163_u - func_70638_az().field_70163_u) > 0.3D)
				{
				    if (AS_BattleTowersCore.instance.noGolemExplosions)
				    {
				    	func_70638_az().func_70097_a(DamageSource.func_76358_a(this), 3.5f);
				    }
				    else
				    {
				        field_70170_p.func_72876_a(this, field_70165_t, field_70163_u-0.3D, field_70161_v, 4F, true);
				    }
				}
                rageCounter = 125;
                explosionAttack = 0;
            }
        }
        
        checkForVictim();
        super.func_70071_h_();
    }
    
	private void checkForVictim()
    {
        if(this.getIsDormant())
        {
            if (!field_70170_p.field_72995_K)
            {
                EntityPlayer entityplayer = field_70170_p.func_72890_a(this, 6D);
                if(entityplayer != null && func_70685_l(entityplayer))
                {
                    setAwake();
                    func_70624_b(entityplayer);
                    rageCounter = 175;
                }
            }
        }
		else if (func_70638_az() != null)
        {
			if (towerY == -1)
			{
			    towerX = (int)field_70165_t;
			    towerY = (int)field_70163_u;
			    towerZ = (int)field_70161_v;
			}

			boolean targetNearby = (func_70638_az().func_70068_e(this) < 6F*6F);

            if(!targetNearby || explosionAttack == 1 || (((this.field_70163_u - func_70638_az().field_70163_u) > 0.3D)))
            {
                rageCounter-=2;
                //System.out.println("Golem losing patience: "+rageCounter);
            }
			else
            {
                rageCounter = 175;
            }
            
            if (attackCounter == 10)
            {
                field_70170_p.func_184133_a(null, func_180425_c(), AS_BattleTowersCore.instance.soundGolemCharge, SoundCategory.HOSTILE, func_70599_aP(), (field_70146_Z.nextFloat() - field_70146_Z.nextFloat()) * 0.2F + 1.0F);
            }
            attackCounter++;
            if (attackCounter >= 20)
            {
                conjureFireBall();
                attackCounter = -40;
            }
        }
        else if (attackCounter > 0)
        {
            attackCounter--;
        }
    }
	
	private void conjureFireBall()
	{
        if (!field_70170_p.field_72995_K)
        {
            double diffX = func_70638_az().field_70165_t - field_70165_t;
            double diffY = (func_70638_az().func_174813_aQ().field_72338_b + (double)(func_70638_az().field_70131_O / 2.0F)) - (field_70163_u + field_70131_O * 0.8D);
            double diffZ = func_70638_az().field_70161_v - field_70161_v;
            
            field_70761_aq = field_70177_z = (-(float)Math.atan2(diffX, diffZ) * 180F) / (float)Math.PI;
            
            field_70170_p.func_184133_a(null, func_180425_c(), SoundEvents.field_187557_bK, SoundCategory.HOSTILE, func_70599_aP(), (field_70146_Z.nextFloat() - field_70146_Z.nextFloat()) * 0.2F + 1.0F);
            AS_EntityGolemFireball entityfireball = new AS_EntityGolemFireball(field_70170_p, this, diffX, diffY, diffZ);
            Vec3d vec3d = func_70676_i(1.0F);
            entityfireball.field_70165_t = field_70165_t + vec3d.field_72450_a * 2D;
            entityfireball.field_70163_u = field_70163_u + (field_70131_O*0.8) + vec3d.field_72448_b * 0.5D;
            entityfireball.field_70161_v = field_70161_v + vec3d.field_72449_c * 2D;
            field_70170_p.func_72838_d(entityfireball);
        }
	}

    @Override
    protected boolean func_70692_ba()
    {
    	return this.field_70128_L;
    }

    @Override
    public void func_70014_b(NBTTagCompound nbttagcompound)
    {
        if (towerY == -1)
        {
            towerX = (int)field_70165_t;
            towerY = (int)field_70163_u;
            towerZ = (int)field_70161_v;
        }
        
        super.func_70014_b(nbttagcompound);
        nbttagcompound.func_74774_a("isDormant", (byte) (this.getIsDormant() ? 1 : 0));
        nbttagcompound.func_74774_a("hasexplosionAttacked", (byte)explosionAttack);
        nbttagcompound.func_74774_a("rageCounter", (byte)rageCounter);
        nbttagcompound.func_74774_a("Drops", (byte)drops);
        nbttagcompound.func_74768_a("towerX", towerX);
        nbttagcompound.func_74768_a("towerY", towerY);
        nbttagcompound.func_74768_a("towerZ", towerZ);
    }

    @Override
    public void func_70037_a(NBTTagCompound nbttagcompound)
    {
        super.func_70037_a(nbttagcompound);
        if ((nbttagcompound.func_74771_c("isDormant") & 0xff) == 1)
        {
        	this.setDormant();
        }
        else
        {
        	this.setAwake();
        }
        explosionAttack = nbttagcompound.func_74771_c("hasexplosionAttacked") & 0xff;
        rageCounter = nbttagcompound.func_74771_c("rageCounter") & 0xff;
        drops = nbttagcompound.func_74771_c("Drops") & 0xff;
        
        towerX = nbttagcompound.func_74762_e("towerX");
        towerY = nbttagcompound.func_74762_e("towerY");
        towerZ = nbttagcompound.func_74762_e("towerZ");
    }
    
    @Override
    public boolean func_70652_k(Entity entity)
    {
        if(field_70122_E)
        {
            double d = entity.field_70165_t - field_70165_t;
            double d1 = entity.field_70161_v - field_70161_v;
            float f1 = MathHelper.func_76133_a(d * d + d1 * d1);
            field_70159_w = (d / (double)f1) * 0.5D * 0.20000000192092895D + field_70159_w * 0.20000000098023224D;
            field_70179_y = (d1 / (double)f1) * 0.5D * 0.10000000192092896D + field_70179_y * 0.20000000098023224D;
        }
        
        return super.func_70652_k(entity);
    }

    @Override
    protected SoundEvent func_184639_G()
    {
        if(!this.getIsDormant())
        {
            return AS_BattleTowersCore.instance.soundGolem;
        }
        else
        {
            return SoundEvents.field_187674_a;
        }
    }

    @Override
    protected SoundEvent func_184601_bQ()
    {
        return AS_BattleTowersCore.instance.soundGolemHurt;
    }

    @Override
    protected SoundEvent func_184615_bR()
    {
        return AS_BattleTowersCore.instance.soundGolemDeath;
    }

    @Override
    protected Item func_146068_u()
    {
        return Items.field_151121_aF;
    }

}
